/*
NAME:       TCPServer [Port number]
SYNOPSIS:    TCPServer
DESCRIPTION:  The program creates a TCP socket in the inet
			listen for connections from TCPClients, accept
			clients into private sockets, and fork a
			an acho process to ``serve'' the cleint.
*/

#include <stdio.h>
#include <errno.h>
#include <sys/time.h>
#include <sys/param.h>
#include <sys/socket.h>
#include <sys/file.h>
#include <netinet/in_systm.h>
#include <netinet/in.h>
#include <netinet/ip.h>
#include <netinet/ip_icmp.h>
#include <netdb.h>

#define MAXHOSTNAME 80

typedef struct {
	char buf[1024];
	int byte;
} Paquete;

void reusePort(int sock);


main( int argc, char *argv[] ) {

	int   sd, psd;
	struct   sockaddr_in server;
	struct  hostent *hp, *gethostbyname();
	struct  servent *sp;
	struct sockaddr_in from;
	int fromlen;
	int length;
	char ThisHost[80];

	char buf[1024],buf2[1024];
	int rc,archivo;
	Paquete paquete;



	if (argc!=2)    {
		printf("\nUsar: vcVRS <puerto vcVRS> \n\n");
		return(-1);
	}

	printf("\n\n\n\n");
	gethostname(ThisHost, MAXHOSTNAME);

	printf("----TCP/Server running at host NAME: %s\n", ThisHost);
	if  ( (hp = gethostbyname(ThisHost)) == NULL ) {
		fprintf(stderr, "Can't find host %s\n", ThisHost);
		exit(-1);
	}
	bcopy ( hp->h_addr, &(server.sin_addr), hp->h_length);
	printf("    (TCP/Server INET ADDRESS is: %s )\n", inet_ntoa(server.sin_addr));

	/* Construct name of socket to send to. */
	server.sin_family = hp->h_addrtype;
	server.sin_addr.s_addr = htonl(INADDR_ANY);

	if (argc == 2)
		server.sin_port = htons(atoi(argv[1]));

	/*   Create socket on which to send  and receive */
	sd = socket (hp->h_addrtype,SOCK_STREAM,0);

	if (sd<0) {
		perror("opening stream socket");
		exit(-1);
	}

	reusePort(sd);

	if ( bind( sd, &server, sizeof(server) ) ) {
		close(sd);
		perror("binding name to stream socket");
		exit(-1);
	}

	length = sizeof(server);
	if ( getsockname (sd,&server,&length) ) {
		perror("getting socket name");
		exit(0);
	}

	printf("Server Port is: %d\n", ntohs(server.sin_port));
	listen(sd,4);
	fromlen = sizeof(from);
	psd  = accept(sd, &from, &fromlen);
	close (sd);

	printf("Serving %s:%d\n", inet_ntoa(from.sin_addr),
		ntohs(from.sin_port));
	if ((hp = gethostbyaddr((char*)&from.sin_addr.s_addr,
		sizeof(from.sin_addr.s_addr),AF_INET)) == NULL)
		fprintf(stderr, "Can't find host %s\n", inet_ntoa(from.sin_addr));
	else
		printf("(Name is : %s)\n", hp->h_name);


	/*      get data from  clients and send it back */


		printf("\n...server is waiting...\n");
		if( (rc=read(psd,(void *)&buf2, sizeof(buf2))) < 0)     //lee el nombre del archivo
			perror("receiving stream  message");

		if (rc > 0){
		buf2[rc]='\0';
		printf("Received: \"%s\"\n", buf2);
		printf("From TCP/Client: %s:%d\n", inet_ntoa(from.sin_addr),
			ntohs(from.sin_port));
		printf("(Name is : %s)\n", hp->h_name);

		//crea archivo
		archivo =open("./codixrecv",O_CREAT|O_WRONLY);
		while(rc=read(psd,(void *)&paquete ,sizeof(paquete))>0)
			write(archivo,paquete.buf,sizeof(paquete.buf));
		printf("archivo recivido\n");
		sprintf(buf,"uudecode -o %s ./codixrecv",buf2);
		printf("%s",buf); //temporal para mostrar si esta correcto el comando
		system("chmod 777 ./codixrecv");
		system(buf);
		close(archivo);
		close (psd);
		system("rm -f ./codixrecv"); //borra el archivo temporal
		exit(0);
		}

}


void reusePort(int s){
	int one=1;

	if ( setsockopt(s,SOL_SOCKET,SO_REUSEADDR,(char *) &one,sizeof(one)) == -1 ) {
		printf("error in setsockopt,SO_REUSEPORT \n");
		exit(-1);
	}

}
